﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XamDataTreeEx
{
    public class CompareBilling : INotifyPropertyChanged
    {
        public CompareBilling()
        { }

        public CompareBilling(string displayData, string subData, bool acceptableDifference, bool canAcceptChildren, bool isChange, int differencesID, bool accepted, string keyDefinition, string keyData, string comparison)
        {
            DisplayData = displayData;
            SubData = subData;
            AcceptableDifference = acceptableDifference;
            CanAcceptChildren = canAcceptChildren;
            IsChange = isChange;
            DifferencesID = differencesID;
            Accepted = accepted;
            KeyDefinition = keyDefinition;
            KeyData = keyData;
            Comparison = comparison;
        }

        #region Properties

        private string _displayData;
        /// <summary>
        /// Display Data
        /// </summary>
        public string DisplayData
        {
            get { return _displayData; }
            set
            {
                if (_displayData != value)
                {
                    _displayData = value;
                    FirePropertyChanged("DisplayData");
                }
            }
        }
        private string _subData;
        /// <summary>
        /// Sub Data
        /// </summary>
        public string SubData
        {
            get { return _subData; }
            set
            {
                if (_subData != value)
                {
                    _subData = value;
                    FirePropertyChanged("SubData");
                }
            }
        }

        private bool _acceptableDifference;
        /// <summary>
        /// Acceptable Difference ?
        /// </summary>
        public bool AcceptableDifference
        {
            get { return _acceptableDifference; }
            set
            {
                if (_acceptableDifference != value)
                {
                    _acceptableDifference = value;
                    FirePropertyChanged("AcceptableDifference");
                }
            }
        }

        private bool _canAcceptChildren;
        /// <summary>
        /// Can Accept Children
        /// </summary>
        public bool CanAcceptChildren
        {
            get { return _canAcceptChildren; }
            set
            {
                if (_canAcceptChildren != value)
                {
                    _canAcceptChildren = value;
                    FirePropertyChanged("CanAcceptChildren");
                }
            }
        }

        private bool _isChange;
        /// <summary>
        /// Is Change
        /// </summary>
        public bool IsChange
        {
            get { return _isChange; }
            set
            {
                if (_isChange != value)
                {
                    _isChange = value;
                    FirePropertyChanged("IsChange");
                }
            }
        }

        private int _differencesID;
        /// <summary>
        /// Differences ID
        /// </summary>
        public int DifferencesID
        {
            get { return _differencesID; }
            set
            {
                if (_differencesID != value)
                {
                    _differencesID = value;
                    FirePropertyChanged("DifferencesID");
                }
            }
        }

        private bool _accepted;
        /// <summary>
        /// Accepted
        /// </summary>
        public bool Accepted
        {
            get { return _accepted; }
            set
            {
                if (_accepted != value)
                {
                    _accepted = value;
                    FirePropertyChanged("Accepted");
                }
            }
        }

        private string _keyDefinition;
        /// <summary>
        /// Key Definition
        /// </summary>
        public string KeyDefinition
        {
            get { return _keyDefinition; }
            set
            {
                if (_keyDefinition != value)
                {
                    _keyDefinition = value;
                    FirePropertyChanged("KeyDefinition");
                }
            }
        }

        private string _keyData;
        /// <summary>
        /// Key Data
        /// </summary>
        public string KeyData
        {
            get { return _keyData; }
            set
            {
                if (_keyData != value)
                {
                    _keyData = value;
                    FirePropertyChanged("KeyData");
                }
            }
        }

        private string _comparison;
        /// <summary>
        /// Comparison
        /// </summary>
        public string Comparison
        {
            get { return _comparison; }
            set
            {
                if (_comparison != value)
                {
                    _comparison = value;
                    FirePropertyChanged("Comparison");
                }
            }
        }

        #endregion

        #region INotifyPropertyChange

        public event PropertyChangedEventHandler PropertyChanged;

        protected void FirePropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));

        }

        #endregion
    }
}

